@echo off

%~d0
cd %~p0

SET LOG_FILE=~eplgOutlookxInst.log
echo. >> %LOG_FILE%
echo START: %0 >> %LOG_FILE%

For /f "tokens=1,2 delims==" %%G in ('"%~dp0\GetInfo" 7 ESETInstallDir') Do (set _ESETInstallDir=%%H)

if exist "%_ESETInstallDir%x86\" goto _64
if exist "%_ESETInstallDir%" goto _32

echo *** EAV/ESS not found! *** | tee -a %LOG_FILE%
goto End


:_64
SET ESET_DIR32=%_ESETInstallDir%x86
SET ESET_DIR64=%_ESETInstallDir%
goto InstCheck
:_32
SET ESET_DIR32=%_ESETInstallDir%
SET ESET_DIR64=
goto InstCheck


:InstCheck
if not "%ESET_DIR64%"=="" echo ESET_DIR64=%ESET_DIR64% | tee -a %LOG_FILE%
echo ESET_DIR32=%ESET_DIR32% | tee -a %LOG_FILE%

SET ALREADY_INSTALLED=0
set SMON32=0
if not exist "%ESET_DIR32%\eplgOutlook.dll" call :FileNotFound "%ESET_DIR32%\eplgOutlook.dll"
if not exist "%ESET_DIR32%\eplgOutlookEmon.dll" call :FileNotFound "%ESET_DIR32%\eplgOutlookEmon.dll"
if exist "%ESET_DIR32%\eplgOutlookSmon.dll" set SMON32=1
if exist "%ESET_DIR32%\~original-eplgOutlook.dll" SET ALREADY_INSTALLED=1
if exist "%ESET_DIR32%\~original-eplgOutlookEmon.dll" SET ALREADY_INSTALLED=1
if exist "%ESET_DIR32%\~original-eplgOutlookSmon.dll" SET ALREADY_INSTALLED=1

if "%ESET_DIR64%"=="" goto SkipX64_a
set SMON64=0
if not exist "%ESET_DIR64%\eplgOutlook.dll" call :FileNotFound "%ESET_DIR64%\eplgOutlook.dll"
if not exist "%ESET_DIR64%\eplgOutlookEmon.dll" call :FileNotFound "%ESET_DIR64%\eplgOutlookEmon.dll"
if exist "%ESET_DIR64%\eplgOutlookSmon.dll" set SMON64=1
if exist "%ESET_DIR64%\~original-eplgOutlook.dll" SET ALREADY_INSTALLED=1
if exist "%ESET_DIR64%\~original-eplgOutlookEmon.dll" SET ALREADY_INSTALLED=1
if exist "%ESET_DIR64%\~original-eplgOutlookSmon.dll" SET ALREADY_INSTALLED=1
:SkipX64_a


if %ALREADY_INSTALLED%==1 goto AlreadyInstalled

call :RenameFile "%ESET_DIR32%" 32 eplgOutlook
call :RenameFile "%ESET_DIR32%" 32 eplgOutlookEmon
if %SMON32%==1 call :RenameFile "%ESET_DIR32%" 32 eplgOutlookSmon

if "%ESET_DIR64%"=="" goto SkipX64_b
call :RenameFile "%ESET_DIR64%" 64 eplgOutlook
call :RenameFile "%ESET_DIR64%" 64 eplgOutlookEmon
if %SMON64%==1 call :RenameFile "%ESET_DIR64%" 64 eplgOutlookSmon
:SkipX64_b


:PrintResult

if not exist "%ESET_DIR32%\eplgOutlook.dll" goto PrintError
if not exist "%ESET_DIR32%\~original-eplgOutlook.dll" goto PrintError

if not exist "%ESET_DIR32%\eplgOutlookEmon.dll" goto PrintError
if not exist "%ESET_DIR32%\~original-eplgOutlookEmon.dll" goto PrintError

if %SMON32%==0 goto SkipSmon32
if not exist "%ESET_DIR32%\eplgOutlookSmon.dll" goto PrintError
if not exist "%ESET_DIR32%\~original-eplgOutlookSmon.dll" goto PrintError
:SkipSmon32

if "%ESET_DIR64%"=="" goto SkipX64_c
if not exist "%ESET_DIR64%\eplgOutlook.dll" goto PrintError
if not exist "%ESET_DIR64%\~original-eplgOutlook.dll" goto PrintError

if not exist "%ESET_DIR64%\eplgOutlookEmon.dll" goto PrintError
if not exist "%ESET_DIR64%\~original-eplgOutlookEmon.dll" goto PrintError

if %SMON64%==0 goto SkipSmon64
if not exist "%ESET_DIR64%\eplgOutlookSmon.dll" goto PrintError
if not exist "%ESET_DIR64%\~original-eplgOutlookSmon.dll" goto PrintError
:SkipSmon64
:SkipX64_c

echo *** Installed OK *** | tee -a %LOG_FILE%
goto End


:AlreadyInstalled
echo *** Already installed! *** | tee -a %LOG_FILE%
goto End

:FileNotFound
echo *** File %1 not found! *** | tee -a %LOG_FILE%
pause
exit 999

:PrintError
echo *** ERROR *** | tee -a %LOG_FILE%
pause
exit 999


:RenameFile
@setlocal

set PATH_WITHOUT_QUOTES=%~1
if not exist "%PATH_WITHOUT_QUOTES%\%3.dll" goto SkipRenameFile

echo Renaming %PATH_WITHOUT_QUOTES%\%3.dll | tee -a %LOG_FILE%

ren "%PATH_WITHOUT_QUOTES%\%3.dll" ~original-%3.dll 2>&1 | tee -a %LOG_FILE%
if not exist "%PATH_WITHOUT_QUOTES%\%3.dll" goto RenameFile_a
echo Error: Cannot rename "%PATH_WITHOUT_QUOTES%\%3.dll" to ~original-%3.dll | tee -a %LOG_FILE%
goto PrintError

:RenameFile_a
copy %2\%3.dll "%PATH_WITHOUT_QUOTES%\%3.dll" 2>&1 | tee -a %LOG_FILE%
if exist "%PATH_WITHOUT_QUOTES%\%3.dll" goto RenameFile_b
echo Error: Cannot copy %2\%3.dll to "%PATH_WITHOUT_QUOTES%\%3.dll" | tee -a %LOG_FILE%
goto PrintError

:RenameFile_b
:SkipRenameFile
@endlocal
@goto :eof

:End

pause
